package fr.enst.cours.network;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.net.UnknownHostException;

public class ClientStringInteractif {

	public static void main(String[] args) {
		Socket connexion = null;
		System.out.println("Tentative de connexion");
		try {
			connexion = new Socket("localhost", 4242);
		} catch (UnknownHostException e) {
			System.err.println("Machine inconnue : localhost");
			System.exit(-1);
		} catch (IOException e) {
			System.err.println("Connexion impossible au serveur");
			System.exit(-1);
		}
		System.out.println("Connecté");
		try {
			ObjectOutputStream out = new ObjectOutputStream(connexion.getOutputStream());
			ObjectInputStream in = new ObjectInputStream(connexion.getInputStream());
			BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));
			String userInput = null;
			do {
				System.out.print("Commande <- ");
				userInput = stdIn.readLine();
				if(userInput!=null) {
					out.writeObject(userInput);
					out.flush();
					System.out.println("-> "+in.readObject());
				}
			} while (!userInput.equals("quit"));
			out.close();
			in.close();
			connexion.close();
			System.out.println("Déconnexion");
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(-1);
		} catch(ClassNotFoundException e) {
			e.printStackTrace();
			System.exit(-1);			
		}
	}

}
