package fr.enst.cours.network;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;

public class EchoServerSingle {

	public static void main(String[] args) {
		ServerSocket serverSocket = null;
		try {
			serverSocket = new ServerSocket(4242);
		} catch (IOException e) {
			System.err.println("Impossible d'ouvrir le port 4242");
			System.exit(-1);
		}
		System.out.println("Serveur démarré");
		Socket clientSocket = null;
		try {
			clientSocket = serverSocket.accept();
		} catch (IOException e) {
			System.err.println("Connexion avec le client impossible");
			System.exit(-1);
		}
		try {
			BufferedReader in = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));
			PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);

			String inputLine = in.readLine();
			while(inputLine!=null) {
				System.out.println("Le client dit : "+inputLine);
				System.out.println("Le serveur répond : "+inputLine);
				out.println(inputLine);
				inputLine = in.readLine();
			}
			out.close();
			in.close();
			clientSocket.close();
			serverSocket.close();

		} catch (IOException e) {
			e.printStackTrace();
			System.exit(-1);
		}
		System.out.println("Arrêt du serveur");
	}
}
