package fr.enst.cours.network;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;

public class EchoServerThread extends Thread {
	private Socket client;

	public EchoServerThread(Socket client) {
		this.client = client;
	}

	@Override
	public void run() {
		try {
			BufferedReader in = new BufferedReader(new InputStreamReader(client.getInputStream()));
			PrintWriter out = new PrintWriter(client.getOutputStream(), true);

			String inputLine = in.readLine();
			while(inputLine!=null) {
				System.out.println(getName()+" : le client dit : "+inputLine);
				System.out.println(getName()+" : le serveur répond : "+inputLine);
				out.println(inputLine);
				inputLine = in.readLine();
			}
			out.close();
			in.close();
			client.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		System.out.println(getName()+" : client déconnecté");
	}
	
}
