package fr.enst.cours.network;

import java.io.EOFException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;

public class EchoStringServerSingle {

	public static void main(String[] args) {
		ServerSocket serverSocket = null;
		try {
			serverSocket = new ServerSocket(4242);
		} catch (IOException e) {
			System.err.println("Impossible d'ouvrir le port 4242");
			System.exit(-1);
		}
		System.out.println("Serveur démarré");
		Socket clientSocket = null;
		try {
			clientSocket = serverSocket.accept();
		} catch (IOException e) {
			System.err.println("Connexion avec le client impossible");
			System.exit(-1);
		}
		try {
			ObjectOutputStream out = new ObjectOutputStream(clientSocket.getOutputStream());
			ObjectInputStream in = new ObjectInputStream(clientSocket.getInputStream());

			String inputLine = (String) in.readObject();
			while (inputLine != null) {
				System.out.println("Le client dit : " + inputLine);
				System.out.println("Le serveur répond : " + inputLine);
				out.writeObject(inputLine);
				out.flush();
				inputLine = (String) in.readObject();
			}
			out.close();
			in.close();
			clientSocket.close();
			serverSocket.close();

		} catch (EOFException e) {
			System.out.println("Client déconnecté");
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(-1);
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
			System.exit(-1);
		}
		System.out.println("Arrêt du serveur");
	}
}
