package fr.enst.cours.network;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;

import fr.enst.cours.thread.BoiteAuxLettres;

public class RdvServer {

	public static Thread ecrivain(final Socket client, final BoiteAuxLettres bal) {
		return new Thread(new Runnable() {
			@Override
			public void run() {
				try {
					BufferedReader in = new BufferedReader(new InputStreamReader(client.getInputStream()));
					PrintWriter out = new PrintWriter(client.getOutputStream(), true);
					out.println("Bonjour Écrivain");
					boolean keepOn = true;
					while (keepOn) {
						String inputLine = in.readLine();
						System.out.println("le client dit : " + inputLine);
						bal.setMessage(inputLine);
						keepOn = !"quit".equals(inputLine);
						if(keepOn) {
							System.out.println("le serveur répond ok");
							out.println("ok");
						} else {
							System.out.println("le serveur répond bye");
							out.println("bye");
						}
					}
					out.println("Au revoir Écrivain");
					out.close();
					in.close();
					client.close();
				} catch (IOException e) {
					e.printStackTrace();
				}

			}
		});
	}

	public static Thread lecteur(final Socket client, final BoiteAuxLettres bal) {
		return new Thread(new Runnable() {
			@Override
			public void run() {
				try {
					PrintWriter out = new PrintWriter(client.getOutputStream(), true);
					out.println("Bonjour Lecteur");
					boolean keepOn = true;
					while (keepOn) {
						String message = bal.getMessage();
						out.println(message);
						keepOn = !"quit".equals(message);
					}
					out.println("Au revoir Lecteur");
					out.close();
					client.close();
				} catch (IOException e) {
					e.printStackTrace();
				}

			}
		});
	}

	public static void main(String[] args) {
		ServerSocket serverSocket = null;
		try {
			serverSocket = new ServerSocket(4242);
		} catch (IOException e) {
			System.err.println("Impossible d'ouvrir le port 4242");
			System.exit(-1);
		}
		System.out.println("Serveur démarré");
		BoiteAuxLettres bal = null;
		Socket clientSocket = null;
		while (true) {
			try {
				clientSocket = serverSocket.accept();
				if (bal == null) {
					bal = new BoiteAuxLettres();
					ecrivain(clientSocket, bal).start();
				} else {
					lecteur(clientSocket, bal).start();
					bal = null;
				}
			} catch (IOException e) {
				System.err.println("Connexion avec le client impossible");
			}
		}

	}

}
